"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minilinksQueryComparison = exports.minilinksQueryLevel = exports.minilinksQueryHandle = exports.minilinksQueryIs = exports.minilinksQuery = void 0;
const client_1 = require("./client");
const minilinksQuery = (query, ml) => {
    if (typeof (query) === 'number')
        return [ml.byId[query]];
    else {
        const q = (0, client_1.serializeQuery)(query);
        const result = (0, exports.minilinksQueryHandle)(q.where, ml);
        return q.limit ? result.slice(q.offset || 0, (q.offset || 0) + (q.limit)) : result;
    }
};
exports.minilinksQuery = minilinksQuery;
const minilinksQueryIs = (query, link) => {
    if (typeof (query) === 'number')
        return link.id === query;
    else {
        const q = (0, client_1.serializeQuery)(query);
        const fields = Object.keys(q);
        return (0, exports.minilinksQueryLevel)(q, link, 'links', fields);
    }
};
exports.minilinksQueryIs = minilinksQueryIs;
const minilinksQueryHandle = (q, ml) => {
    const fields = Object.keys(q);
    return ml.links.filter((link) => {
        return (0, exports.minilinksQueryLevel)(q, link, 'links', fields);
    });
};
exports.minilinksQueryHandle = minilinksQueryHandle;
const minilinksQueryLevel = (q, link, env = 'links', fields) => {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    if (env === 'links') {
        for (const f in fields) {
            const field = fields[f];
            if ((_b = (_a = client_1._serialize === null || client_1._serialize === void 0 ? void 0 : client_1._serialize[env]) === null || _a === void 0 ? void 0 : _a.fields) === null || _b === void 0 ? void 0 : _b[field]) {
                if (!(0, exports.minilinksQueryComparison)(q, link, field, env)) {
                    return false;
                }
            }
            else {
                if (((_d = (_c = client_1._serialize === null || client_1._serialize === void 0 ? void 0 : client_1._serialize[env]) === null || _c === void 0 ? void 0 : _c.relations) === null || _d === void 0 ? void 0 : _d[field]) === 'links') {
                    if (typeof (link[field]) === 'object') {
                        if (typeof (link[field].length) === 'number') {
                            if (!link[field].length)
                                return false;
                            const subfields = Object.keys(q[field]);
                            let found = false;
                            for (const sub in link[field]) {
                                const sublink = link[field][sub];
                                if ((0, exports.minilinksQueryLevel)(q[field], sublink, env, subfields)) {
                                    found = true;
                                    break;
                                }
                            }
                            if (!found)
                                return false;
                        }
                        else {
                            if (!(0, exports.minilinksQueryLevel)(q[field], link[field], env, fields)) {
                                return false;
                            }
                        }
                    }
                }
                else if (((_f = (_e = client_1._serialize === null || client_1._serialize === void 0 ? void 0 : client_1._serialize[env]) === null || _e === void 0 ? void 0 : _e.relations) === null || _f === void 0 ? void 0 : _f[field]) === 'value') {
                    if (!(0, exports.minilinksQueryLevel)(q[field], link[field], 'value', fields)) {
                        return false;
                    }
                }
                else {
                    return false;
                }
            }
        }
    }
    else if (env === 'value') {
        for (const f in fields) {
            const field = fields[f];
            if ((_h = (_g = client_1._serialize === null || client_1._serialize === void 0 ? void 0 : client_1._serialize[env]) === null || _g === void 0 ? void 0 : _g.fields) === null || _h === void 0 ? void 0 : _h[field]) {
                if (!(0, exports.minilinksQueryComparison)(q, link, field, env)) {
                    return false;
                }
            }
            else {
                return false;
            }
        }
    }
    else {
        return false;
    }
    return true;
};
exports.minilinksQueryLevel = minilinksQueryLevel;
const minilinksQueryComparison = (q, link, field, env = 'links') => {
    const comp = q[field];
    if (comp.hasOwnProperty('_eq')) {
        if (link[field] !== comp._eq)
            return false;
    }
    if (comp.hasOwnProperty('_neq')) {
        if (link[field] === comp._neq)
            return false;
    }
    if (comp.hasOwnProperty('_gt')) {
        if (!(link[field] > comp._gt))
            return false;
    }
    if (comp.hasOwnProperty('_gte')) {
        if (!(link[field] >= comp._gte))
            return false;
    }
    if (comp.hasOwnProperty('_lt')) {
        if (!(link[field] < comp._lt))
            return false;
    }
    if (comp.hasOwnProperty('_lte')) {
        if (!(link[field] <= comp._lte))
            return false;
    }
    if (comp.hasOwnProperty('_is_null')) {
        if ((link[field] === null) === comp._is_null)
            return false;
    }
    if (comp.hasOwnProperty('_in')) {
        if (!comp._in.contain(link[field]))
            return false;
    }
    if (comp.hasOwnProperty('_nin')) {
        if (comp._nin.contain(link[field]))
            return false;
    }
    return true;
};
exports.minilinksQueryComparison = minilinksQueryComparison;
//# sourceMappingURL=minilinks-query.js.map